﻿
using System;
using Wisej.Web;

namespace Wisej.AlertBoxCounter
{
	public partial class Window1 : Form
	{
		private readonly int TIMEOUT = 5000;
		private int counter = 0;

		private Timer timer;
		public Window1()
		{
			InitializeComponent();
		}

		protected override void OnLoad(EventArgs e)
		{
			base.OnLoad(e);
			Application.Session.AlertBoxCounter = 0;

			timer = new Timer();
			timer.Tick += Timer1_Tick;
			timer.Interval = TIMEOUT;
			timer.Enabled = false;
		}

		private void Timer1_Tick(object sender, EventArgs e)
		{
			Application.Session.AlertBoxCounter = 0;
			timer.Enabled = false;
		}

		private async System.Threading.Tasks.Task ShowAlert(string message)
		{			
			// show the alert box.
			AlertBox.Show("Alert Box " + counter, MessageBoxIcon.Information, false, System.Drawing.ContentAlignment.BottomRight, TIMEOUT);

			// increment the counter.
			counter++;

			// reset the timeout counter in session variable
			Application.Session.AlertBoxTimeout = TIMEOUT;
			
			// wait for the timeout.
			await System.Threading.Tasks.Task.Delay(TIMEOUT);
		}

		//Show alert box only when the timeout period has elapsed
		private async void button1_Click(object sender, EventArgs e)
		{
			if (Application.Session.AlertBoxCounter <= 0)
			{
				timer.Enabled = true;
				await ShowAlert("AlertBox Number " + counter);
			}
		}
	}
}
